function obj=invgammacost(X,A,S)

%Evaluate the cost term between the observation matrix X and the model A * S,
%assuming the inverse gamma observation model
%
%Usage: obj=invgammacost(X,A,S)
%
%input:
%
%X  observation matrix
%A  gain matrix
%S  source matrix
%
%output:
%
%obj value of the cost term

%Tuomas Virtanen 2007


V=A*S;

notvalid=(V==0|X==0);
V(notvalid)=1;
X(notvalid)=1;

D=log(X./V)-1+V./X;

obj=sum(D(:));


