function obj=logcost(X,A,S)

%Evaluate the cost term between the observation matrix X and the model
%A * S for the variance, assuming Gaussian observation model.
%
%Usage: obj=logcost(X,A,S)
%
%Input:
%
%X   observation matrix
%A   gain matrix
%S   source matrix
%
%Output:
%
%obj value of the cost term

%Tuomas Virtanen 2007


%L=abs(log(X)-log(A*S));
%obj=sum(sum(L));

V=A*S;

notvalid=(V==0|X==0);
V(notvalid)=1;
X(notvalid)=1;

D=X./V-1-log(X./V);
%D(isnan(D))=0;
obj=sum(sum(D));


