function dA=loggrad(A,S,X)

%gradient of the log-distance (see Abdallah&Plumbley, ISMIR 2004)
%
%input: A  gain matrix
%       S  source matrix
%       X  observation matrix
%
%output: dA  gradient of A
%


V=A*S;
notvalid=(V==0|X==0);
V(notvalid)=1;
X(notvalid)=1;


dA=(ones(size(X))./V-X./V.^2)*S';




