function gA=sqdiffgrad(A,diff_c)

%gradient of squared difference along the first dimension
%
%assumes unity norm of each column
%

if 0 %fixed norm approximation

  gA=2*A;

  gA([1 end],:)=gA([1 end],:)/2;

  gA(1:end-1,:)=gA(1:end-1,:)-A(2:end,:);
  gA(2:end,:)=gA(2:end,:)-A(1:end-1,:);

  gA=gA*2;

else %exact gradient

  if length(diff_c)==1
  
    gA=2*A;

    gA([1 end],:)=gA([1 end],:)/2;

    gA(1:end-1,:)=gA(1:end-1,:)-A(2:end,:);
    gA(2:end,:)=gA(2:end,:)-A(1:end-1,:);

    gA=gA*2;

    tot_diff=sum(diff(A,1,1).^2);
    gA=gA-2*repmat(tot_diff,size(A,1),1).*A;

  else
    %different weight for positive and negative gains

    diff_A=diff(A,1,1);

    positive=(diff_A>0);
    diff_W=repmat(diff_c(2),size(positive));
    diff_W(positive)=1/diff_c(2);
    
    gA=zeros(size(A));
    gA(2:end,:)=gA(2:end,:)+2*diff_W.*diff_A;
    gA(1:end-1,:)=gA(1:end-1,:)-2*diff_W.*diff_A;
    
    tot_diff=sum((diff_A.^2).*diff_W);
    gA=gA-2*repmat(tot_diff,size(A,1),1).*A;
    
  end
  
end
